%     NITOOL     NATURE INSPIRED TOOLBOX

% ==============================================
%   PROGRAM AIM : Ackley Function
%    OUT = [ 20 + e ...
%            -20*exp(-0.2*sqrt((1/n)*sum(x.^2,2))) ...
%            -exp((1/n)*sum(cos(2*pi*x),2))];
%       Minima 0 at all x = 0
% ==============================================
%   USAGE :
%         1. OUT = ackley([1,2,3;4,5,6])
% ==============================================
%   SATVIR SINGH SIDHU, ARUN KHOSLA, JASBIR SINGH SAINI
%   JULY 2009
%   COPYRIGHT RESERVED
% ==============================================

function [OUT]=Ackley(in)

% Dimension : x1, x2, ..., xn
 n=length(in(1,:));

 x=in;
 e=exp(1);

 OUT = (20 + e ...
     -20*exp(-0.2*sqrt((1/n).*sum(x.^2,2))) ...
     -exp((1/n).*sum(cos(2*pi*x),2)));
 return